# TODO: May 4, 2023: Commented out as it is not being used
#
# module DM::Bevel
#
#   class BevelLimiter
#     include GeometryMixin
#
#     # @return [BevelData]
#     attr_reader :bevel_data
#
#     # @param bevel_data [BevelData]
#     def initialize(bevel_data)
#       # @type [BevelData]
#       @bevel_data = bevel_data
#       # @type [Array<CollisionReport>]
#       @collision_reports = []
#     end
#
#     def clear
#       @collision_reports.clear
#     end
#
#     # @return [FLoat, Nil]
#     def max_edge_offset
#       return nil if @collision_reports.empty?
#
#       @collision_reports.first.max_edge_offset
#     end
#
#     # @return [Array<CollisionReport>, Nil] If Nil, then it did not hit a limit.
#     def collision_reports
#       return nil if @collision_reports.empty?
#
#       if self.bevel_data.params.edge_offset <= self.max_edge_offset
#         nil
#       else
#         @collision_reports.clone
#       end
#     end
#
#     # @return [Array<CollisionReport>]
#     def generate_results
#       raise UnexpectedStateError, "bevel_data not initialized" if self.bevel_data.affected_corners.nil?
#
#       @collision_reports = self.calculate_collision_reports
#       self.collision_reports
#     end
#
#     private
#
#     # @return [Array<CollisionReport>]
#     def calculate_collision_reports
#       primary_edges = self.bevel_data.primary_edges
#       face_to_vertex_to_face_corner = Hash.new {|h,k| h[k] = {}}
#       self.bevel_data.affected_corners.each_pair do |vertex, corner|
#         corner.face_corners.each do |face_corner|
#           next if face_corner.all_secondary?
#
#           face_to_vertex_to_face_corner[face_corner.face][vertex] = face_corner
#         end
#       end
#
#       face_loop_to_bevel_edge_bounds = Hash.new {|h,k| h[k] = []}
#       self.bevel_data.affected_faces.each do |face|
#         face_loops = FaceLoops.new(face)
#
#         face_loops.loop_to_loop_vertices.each_pair do |loop, loop_vertices|
#           loop_vertices.length.times do |lv_i|
#             start_loop_vertex = loop_vertices[lv_i]
#             end_loop_vertex = loop_vertices[lv_i + 1]
#             end_loop_vertex = loop_vertices[0] if end_loop_vertex.nil?
#
#             # Only care about primary edges
#             common_edge = start_loop_vertex.get_shared_edge(end_loop_vertex)
#             next unless primary_edges.include?(common_edge)
#
#             start_face_corner = face_to_vertex_to_face_corner[face][start_loop_vertex.vertex]
#             end_face_corner = face_to_vertex_to_face_corner[face][end_loop_vertex.vertex]
#
#             edge_bound = BevelEdgeBounds.new(face_loops, start_loop_vertex, start_face_corner, end_loop_vertex, end_face_corner)
#             face_loop_to_bevel_edge_bounds[face_loops] << edge_bound
#           end
#         end
#       end
#
#       all_collision_reports = []
#       face_loop_to_bevel_edge_bounds.each_pair do |face_loops, bevel_edge_bounds|
#         # @type [FaceLoops]
#         face_loops = face_loops
#         # @type [Array<BevelEdgeBounds>]
#         bevel_edge_bounds = bevel_edge_bounds
#
#         bevel_edge_bounds.each do |edge_bound|
#           face_loops.loop_to_loop_vertices.each_pair do |loop, loop_vertices|
#             loop_vertices.each do |loop_vertex|
#               next if edge_bound.loop_vertices.include?(loop_vertex)
#
#               vertex_report = edge_bound.collision_result_for_vertex(loop_vertex.vertex)
#               all_collision_reports << vertex_report unless vertex_report.nil?
#
#               next_edge = loop_vertex.next_edge
#               next if primary_edges.include?(next_edge)
#
#               edge_reports = edge_bound.collision_results_for_edge(next_edge)
#               all_collision_reports.concat(edge_reports)
#             end
#           end
#
#           bevel_edge_bounds.each do |other_bevel_bound|
#             next if edge_bound == other_bevel_bound
#
#             edge_bound_results = edge_bound.collision_results_for_edge_bound(other_bevel_bound)
#             all_collision_reports.concat(edge_bound_results)
#           end
#         end
#       end
#
#       raise UnexpectedStateError if all_collision_reports.empty? # TODO: Logic check
#
#       # TODO: Probably need to return all matching reports so the tool can display them.
#       min_report = all_collision_reports.min {|a,b| a.max_edge_offset <=> b.max_edge_offset }
#       all_collision_reports = [min_report]
#       self.debug_draw_reports(all_collision_reports, min_report)
#
#       [min_report]
#     end
#
#     # # TODO: Debug function
#     # @param all_collision_reports [Array<CollisionReport>]
#     # @param min_report [CollisionReport]
#     def debug_draw_reports(all_collision_reports, min_report)
#       all_collision_reports.each do |collision_report|
#         # next unless collision_report.edge_bound.face.get_attribute('test','test')
#
#         edge_offset = collision_report.max_edge_offset.truncate(4)
#         if collision_report.instance_of?(VertexCollisionReport)
#           DB.draw_pt(collision_report.colliding_vertex.position, 10, 2, 'green')
#           DB.draw_text(collision_report.colliding_vertex.position, edge_offset)
#
#           if collision_report == min_report
#             mid_pt = self.linear_combination(collision_report.edge_bound.edge.start.position, collision_report.edge_bound.edge.end.position)
#             DB.draw_edges(collision_report.edge_bound.edge)
#             DB.draw_line2d([collision_report.colliding_vertex.position, mid_pt], 2, 'purple', '-')
#           end
#         elsif collision_report.instance_of?(EdgeCollisionReport)
#           DB.draw_pt(collision_report.collision_pt, 10, 2, 'purple')
#           DB.draw_text(collision_report.collision_pt, edge_offset)
#
#           if collision_report == min_report
#             mid_pt = self.linear_combination(collision_report.edge_bound.edge.start.position, collision_report.edge_bound.edge.end.position)
#             DB.draw_edges(collision_report.edge_bound.edge)
#             DB.draw_line2d([collision_report.collision_pt, mid_pt], 2, 'purple', '-')
#             DB.draw_edges(collision_report.colliding_edge)
#           end
#         elsif collision_report.instance_of?(BoundCollisionReport)
#           DB.draw_pt(collision_report.collision_pt, 25, 5, 'red')
#           DB.draw_text(collision_report.collision_pt, edge_offset)
#           if collision_report == min_report
#             mid_pt = self.linear_combination(collision_report.edge_bound.edge.start.position, collision_report.edge_bound.edge.end.position)
#             DB.draw_edges(collision_report.edge_bound.edge)
#             DB.draw_line2d([collision_report.collision_pt, mid_pt], 2, 'purple', '-')
#             DB.draw_edges(collision_report.colliding_edge_bound.edge)
#           end
#         else
#           # TODO: Do the math to get the proper midpt"
#           mid_pt = self.linear_combination(collision_report.shared_edge.start.position, collision_report.shared_edge.end.position)
#           DB.draw_pt(mid_pt,20, 7, 'gray');
#           DB.draw_text(mid_pt, edge_offset)
#           if collision_report == min_report
#             DB.draw_edges(collision_report.shared_edge)
#           end
#         end
#       end
#     end
#
#
#   end
#
#
# end