
module DM::Bevel

  class CacheManager

    def initialize
      @hash = {}
      # @hash_with_sub_key = Hash.nw {|h,k| h[k] = {}}
    end

    # @block Sets the value.
    #
    # @param key [Object]
    # @return [Object]
    def retrieve(key)
      return @hash[key] unless @hash[key].nil?

      value = yield if block_given?
      return nil if value.nil?

      @hash[key] = value
      value
    end

    def retrieve_with_sub_key(key, sub_key)
      arr = @hash[key]
      unless arr.nil? || arr.empty?
        value = arr[sub_key]
        return value unless value.nil?
      end

      value = yield if block_given?
      return nil if value.nil?

      @hash[key] = {} if @hash[key].nil?
      @hash[key][sub_key] = value
      value
    end

    def clear
      @hash.clear
    end

    def inspect
      self.to_s
    end

  end

end