# # TODO: May 4, 2023: Commented out as it is not being used.
# module DM::Bevel
#
#   class BevelEdgeBounds
#     include GeometryMixin
#
#     # @return [FaceLoops]
#     attr_reader :face_loops
#     # @return [LoopVertex]
#     attr_reader :start_loop_vertex
#     # @return [LoopVertex]
#     attr_reader :end_loop_vertex
#
#     # @param face_loops [FaceLoops]
#     # @param start_loop_vertex [LoopVertex]
#     # @param end_loop_vertex [LoopVertex]
#     def initialize(face_loops, start_loop_vertex, start_face_corner, end_loop_vertex, end_face_corner)
#       raise UnexpectedTypeError, "face_loops must be of type FaceLoops" unless face_loops.instance_of?(FaceLoops)
#       raise UnexpectedTypeError, "start_loop_vertex must be of type LoopVertex" unless start_loop_vertex.instance_of?(LoopVertex)
#       raise UnexpectedTypeError, "end_loop_vertex must be of type LoopVertex" unless end_loop_vertex.instance_of?(LoopVertex)
#
#       all_loop_vertices = face_loops.loop_to_loop_vertices.values.flat_map {|loop_vertices| loop_vertices}
#       raise UnexpectedStateError, "start_loop_vertex does not belong to this face_loops" unless all_loop_vertices.include?(start_loop_vertex)
#       raise UnexpectedStateError, "end_loop_vertex does not belong to this face_loops" unless all_loop_vertices.include?(end_loop_vertex)
#       raise UnexpectedStateError, "start_loop_vertex and end_loop_vertex are not adjacent" if start_loop_vertex.get_shared_edge(end_loop_vertex).nil?
#
#       raise UnexpectedTypeError, "start_face_corner must of of type FaceCorner" unless start_face_corner.is_a?(FaceCorner)
#       raise UnexpectedTypeError, "end_face_corner must of of type FaceCorner" unless end_face_corner.is_a?(FaceCorner)
#       raise UnexpectedStateError, "start_face_corner and start_loop_vertex are not at the same vertex" unless start_loop_vertex.vertex == start_face_corner.vertex
#       raise UnexpectedStateError, "end_loop_vertex and end_loop_vertex are not at the same vertex" unless end_loop_vertex.vertex == end_loop_vertex.vertex
#       raise UnexpectedStateError, "start_face_corner is not on same face as face_loops" unless face_loops.face == start_face_corner.face
#       raise UnexpectedStateError, "end_face_corner is not on same face as face_loops" unless face_loops.face == end_face_corner.face
#
#       @face_loops = face_loops
#       @start_loop_vertex = start_loop_vertex
#       @end_loop_vertex = end_loop_vertex
#
#       @loop_vertex_to_face_corner = {}
#       @loop_vertex_to_face_corner[start_loop_vertex] = start_face_corner
#       @loop_vertex_to_face_corner[end_loop_vertex] = end_face_corner
#
#       @cache_manager = CacheManager.new
#     end
#
#     # @return [Array<LoopVertex>]
#     def loop_vertices
#       val = @cache_manager.retrieve(:loop_vertices) do
#         [self.start_loop_vertex, self.end_loop_vertex]
#       end
#       val
#     end
#
#     # @return [Sketchup::Face]
#     def face
#       self.face_loops.face
#     end
#
#     # @return [Sketchup::Edge]
#     def edge
#       val = @cache_manager.retrieve(:edge) do
#         self.start_loop_vertex.get_shared_edge(self.end_loop_vertex)
#       end
#       val
#     end
#
#     # @return [Array<Geom::Point3d, Geom::Vector3d>]
#     def edge_line
#       val = @cache_manager.retrieve(:edge_line) do
#         [self.start_loop_vertex.position, self.start_loop_vertex.position.vector_to(self.end_loop_vertex.position).normalize]
#       end
#       val
#     end
#
#     # @return [Sketchup::Edge]
#     def prev_edge
#       val = @cache_manager.retrieve(:prev_edge) do
#         (self.start_loop_vertex.edges - [self.edge]).first
#       end
#       val
#     end
#
#     # @return [Sketchup::Edge]
#     def next_edge
#       val = @cache_manager.retrieve(:next_edge) do
#         (self.end_loop_vertex.edges - [self.edge]).first
#       end
#       val
#     end
#
#     # @param at_loop_vertex [LoopVertex]
#     # @return [FaceCorner, Nil]
#     def face_corner(at_loop_vertex)
#       @loop_vertex_to_face_corner[at_loop_vertex]
#     end
#
#     # @return [Array<Array<Geom::Point3d, Geom::Vector3d>>]
#     #   Index 0: Start Plane
#     #   Index 1: Inner (Main) Plane
#     #   Index 2: End Plane
#     def plane_bounds
#       val = @cache_manager.retrieve(:plane_bounds) do
#         start_pt = self.start_loop_vertex.position
#         end_pt = self.end_loop_vertex.position
#         edge_vec = start_pt.vector_to(end_pt).normalize
#         face = self.face
#
#         bounds = []
#         start_face_corner = self.face_corner(self.start_loop_vertex)
#
#         if start_face_corner.instance_of?(ParallelFaceCorner)
#           bounds << [start_pt, edge_vec.clone]
#         else
#           if start_face_corner.all_primary?
#             vec = face.normal * start_face_corner.mid_vector
#             vec.reverse! unless self.similar_direction?(edge_vec, vec)
#             bounds << [start_pt, vec]
#           else
#             perp_vec = self.perpendicular_vector(self.prev_edge, face)
#             perp_vec.reverse! unless start_face_corner.face_between?
#             bounds << [start_pt, perp_vec]
#           end
#         end
#
#         bounds << [start_pt, self.perpendicular_vector(self.edge, face)]
#
#         end_face_corner = self.face_corner(self.end_loop_vertex)
#         if end_face_corner.instance_of?(ParallelFaceCorner)
#           bounds << [end_pt, edge_vec.reverse]
#         else
#           if end_face_corner.all_primary?
#             vec = face.normal * end_face_corner.mid_vector
#             vec.reverse! unless self.similar_direction?(edge_vec.reverse, vec)
#             bounds << [end_pt, vec]
#           else
#             perp_vec = self.perpendicular_vector(self.next_edge, face)
#             perp_vec.reverse! unless end_face_corner.face_between?
#             bounds << [end_pt, perp_vec]
#           end
#         end
#
#         # TODO: DEbug
#         # if self.edge.get_attribute('test','test')
#         # DB.draw_pt_text(start_pt, 'start')
#         # DB.draw_pt_text(end_pt, 'end')
#         # DB.draw_vector(start_pt.vector_to(end_pt).reverse.normalize, end_pt)
#         # bounds.each_with_index do |bound, i|
#         #   edge_vec = start_pt.vector_to(end_pt)
#         #   if i == 0
#         #     DB.draw_vector(bound[1], start_pt.offset(edge_vec, 4), color: 'yellow')
#         #   elsif i == 1
#         #     DB.draw_vector(bound[1], self.linear_combination(start_pt, end_pt), color: 'yellow')
#         #   else
#         #     DB.draw_vector(bound[1], end_pt.offset(edge_vec.reverse, 4), color: 'yellow')
#         #   end
#         # end
#         # end
#         bounds
#       end
#       val.clone
#     end
#
#     # The start and end lines.
#     # @return [Array<Array<Geom::Point3d, Geom::Vector3d>>]
#     def bound_lines
#       val = @cache_manager.retrieve(:bound_lines) do
#         bounds = []
#         [self.start_loop_vertex, self.end_loop_vertex].each do |loop_vertex|
#           face_corner = self.face_corner(loop_vertex)
#           if face_corner.instance_of?(ParallelFaceCorner)
#             bounds << [loop_vertex.position, face_corner.mid_vector]
#           else
#             if face_corner.all_primary?
#               bounds << [loop_vertex.position, face_corner.mid_vector]
#             else
#               edge_vec = face_corner.primary_secondary[1].edge_vector
#               edge_vec.reverse! unless face_corner.face_between?
#               bounds << [loop_vertex.position, edge_vec]
#             end
#           end
#           end
#         bounds
#       end
#       val
#     end
#
#
#     # @param vertex [Sketchup::Vertex]
#     # @return [VertexCollisionReport, Nil]
#     def collision_result_for_vertex(vertex)
#       vert_pt = vertex.position
#       result = self.classify_point(vert_pt)
#       return nil if result == CollisionResult::NotInBounds
#
#       # Check if we can still bevel past the vert_pt.
#       unless CollisionResult.contains?(result, CollisionResult::OnMainPlane)
#         if CollisionResult.contains?(result, CollisionResult::OnStartPlane)
#           offset_vec = self.start_loop_vertex.prev_line[1]
#         elsif CollisionResult.contains?(result, CollisionResult::OnEndPlane)
#           offset_vec = self.end_loop_vertex.next_line[1]
#         else
#           offset_vec = self.plane_bounds[1][1] # Take the perpendicular vec of the main edge
#         end
#
#         proj_pt = vert_pt.offset(offset_vec, 0.01)
#          return nil if self.can_bevel_to_pt?(proj_pt)
#       end
#
#       VertexCollisionReport.new(self, result, vertex)
#     end
#
#     # @param edge [Sketchup::Edge]
#     # @return [Array<EdgeCollisionReport>]
#     def collision_results_for_edge(edge)
#       edge_line = [edge.start.position, edge.start.position.vector_to(edge.end.position).normalize]
#       valid_edge_collision_reports = []
#       self.plane_bounds.each do |plane|
#         int_pt = Geom.intersect_line_plane(edge_line, plane)
#         next if int_pt.nil?
#
#         # Ignore if it's on the vertics of the edge.
#         next if [edge.start.position, edge.end.position].include?(int_pt)
#         next unless self.point_on_face?(self.face_loops.face, int_pt)
#         next unless self.point_on_line?(edge.start.position, edge.end.position, int_pt)
#
#         result = self.classify_point(int_pt)
#         next if result == CollisionResult::NotInBounds
#
#         valid_edge_collision_reports << EdgeCollisionReport.new(self, result, edge, int_pt)
#       end
#       valid_edge_collision_reports
#     end
#
#     # @param other_edge_bound [BevelEdgeBounds]
#     # @return [Array<BoundCollisionReport, SharedEdgeCollisionReport>]
#     def collision_results_for_edge_bound(other_edge_bound)
#       valid_bound_collision_reports = []
#       other_bounds = other_edge_bound.plane_bounds
#       self.loop_vertices.each do |loop_vertex|
#         face_corner = self.face_corner(loop_vertex)
#         if face_corner.instance_of?(ParallelFaceCorner)
#           offset_vec = face_corner.mid_vector
#         else
#           if face_corner.all_primary?
#             offset_vec = face_corner.mid_vector
#           else
#             primary_secondary = face_corner.primary_secondary
#             secondary_edge = primary_secondary[1].edge
#
#             offset_vec = primary_secondary[1].edge_vector
#             offset_vec.reverse! unless face_corner.face_between?
#           end
#         end
#
#         line = [loop_vertex.position, offset_vec]
#         other_bounds.each_with_index do |other_bound, b_i|
#           if b_i == 0
#             # start bound
#             other_edge = other_edge_bound.prev_edge
#           elsif b_i == 1
#             # IF they're share a loop vertex. Skip the main edge comparison.
#             next if other_edge_bound.loop_vertices.include?(loop_vertex)
#           elsif b_i == 2
#             # end bound
#             other_edge = other_edge_bound.next_edge
#           end
#
#           if !secondary_edge.nil? && secondary_edge == other_edge
#             # Check if the other_bound edges are shared. Only valid if the shared edge is a Secondary edge
#             result = self.prev_edge == secondary_edge ? CollisionResult::OnStartPlane : CollisionResult::OnEndPlane
#             result |= CollisionResult::InsideBounds
#
#             other_result = other_edge_bound.prev_edge == secondary_edge ? CollisionResult::OnStartPlane : CollisionResult::OnEndPlane
#             other_result |= CollisionResult::InsideBounds
#
#             valid_bound_collision_reports << SharedEdgeCollisionReport.new(self, result, other_edge_bound, other_result, secondary_edge)
#           else
#             int_pt = Geom.intersect_line_plane(line, other_bound)
#             next if int_pt.nil?
#
#             # If it falls on the vertex of the other_edge_bound.edge, then ignore it. (That should be handled by collision_result_for_vertex)
#             next if [other_edge_bound.edge.start.position, other_edge_bound.edge.end.position].include?(int_pt)
#
#             if b_i == 1 # OnMainPlane of the other_edge_bound
#               unless self.is_edge_part_of_inner_loop?(other_edge_bound.edge)
#                 # Only do this check if other_edge_bound.edge is NOT part of a hole (inner_loop).
#                 next unless self.point_on_line?(other_edge_bound.edge.start.position, other_edge_bound.edge.end.position, int_pt)
#               end
#
#               # This is a bit of a cheat. When colliding with OnMainPlane of the other_edge_bound, we need to calculate the expected
#               # collision pt. Then, we check if both edges can actually bevel to it. The logic to calculate the distance is in the BoundCollisionReport,
#               # so create an instance of that first, then check. If it's valid, then we're good.
#               result = loop_vertex == self.start_loop_vertex ? CollisionResult::OnStartPlane : CollisionResult::OnEndPlane
#               result |= CollisionResult::InsideBounds
#               other_result = CollisionResult::InsideBounds | CollisionResult::OnMainPlane
#
#               collision_report = BoundCollisionReport.new(self, result, other_edge_bound, other_result, int_pt)
#               collision_pt = collision_report.calculated_collision_pt
#
#               # Make sure the result is visible for both edge_bounds
#               result = self.classify_point(collision_pt)
#               next if result == CollisionResult::NotInBounds
#
#               other_result = other_edge_bound.classify_point(collision_pt)
#               next if other_result == CollisionResult::NotInBounds
#
#               valid_bound_collision_reports << collision_report
#             else
#               # OnStartPlane / OnEndPlane
#
#               # Make sure the result is visible for both edge_bounds
#               result = self.classify_point(int_pt)
#               next if result == CollisionResult::NotInBounds
#
#               other_result = other_edge_bound.classify_point(int_pt)
#               next if other_result == CollisionResult::NotInBounds
#
#               # TODO: Not sure about this.
#               # IF the collision occurs on the Start/End Planes of both edges, then we must check if they're equal distances apart.
#               # If they are not, they'll never collide, so we can skip that.
#               proj_pt = int_pt.project_to_line(self.edge_line)
#               colliding_proj_pt = int_pt.project_to_line(other_edge_bound.edge_line)
#               next unless self.float_equal?(proj_pt.distance(int_pt).to_f, colliding_proj_pt.distance(int_pt).to_f)
#
#               valid_bound_collision_reports << BoundCollisionReport.new(self, result, other_edge_bound, other_result, int_pt)
#             end
#
#
#           end
#
#
#           # DB.draw_vector(other_bound[1], other_bound[0])
#           # # DB.draw_pt_text(int_pt, [result, other_result])
#           # mid_pt = self.linear_combination(self.start_loop_vertex.position, self.end_loop_vertex.position)
#           # DB.draw_line2d([int_pt, mid_pt], 2, 'purple','-')
#           # DB.draw_line2d([int_pt, other_bound[0]], 2, 'green','-')
#         end
#       end
#
#       valid_bound_collision_reports
#     end
#
#
#     # @param point [Geom::Point3d]
#     # @return [Integer] Returns a BitFlag of CollisionResult
#     def classify_point(point)
#       return CollisionResult::NotInBounds unless self.point_on_face?(self.face, point)
#
#       bounds = self.plane_bounds
#       on_plane_result = CollisionResult::NotInBounds
#
#       num_within = 0
#       bounds.each_with_index do |plane, p_i|
#         break if self.point_behind?(plane, point)
#
#         num_within += 1
#         if point.on_plane?(plane)
#           if p_i == 0
#             on_plane_result |= CollisionResult::OnStartPlane
#           elsif p_i == 1
#             on_plane_result |= CollisionResult::OnMainPlane
#           else
#             on_plane_result |= CollisionResult::OnEndPlane
#           end
#         end
#       end
#
#       return CollisionResult::NotInBounds unless num_within == 3
#       return CollisionResult::NotInBounds unless self.can_bevel_to_pt?(point)
#
#       result = CollisionResult::InsideBounds
#       result |= on_plane_result
#       result
#     end
#
#     # @param pt [Geom::Point3d]
#     # @return [Boolean]
#     def can_bevel_to_pt?(pt)
#       # TODO: Caching idea: Could cache the furthest pt offset and the 'area' of the bevel'ed shape. Then use Geom.point_int_polygon to check if point insde?
#       #       Problem is holes. Might get false sense of validity.
#       # TODO: Apr 11, 2023: Optimized a bit but will probably need more.
#       return true if self.point_on_line?(self.start_loop_vertex.position, self.end_loop_vertex.position, pt)
#
#       temp_plane = [pt, self.plane_bounds[1][1]]
#       bound_lines = self.bound_lines
#
#       start_pt = self.start_loop_vertex.position
#       proj_start_pt = Geom.intersect_line_plane(bound_lines[0], temp_plane)
#       return false unless self.point_on_face?(self.face, proj_start_pt)
#
#       end_pt = self.end_loop_vertex.position
#       proj_end_pt = Geom.intersect_line_plane(bound_lines[1], temp_plane)
#       return false unless self.point_on_face?(self.face, proj_end_pt)
#
#       # Check if it is even possible to reach this point if we were to bevel this edge.
#       line_pts = []
#       line_pts << [start_pt, proj_start_pt]
#       line_pts << [proj_start_pt, proj_end_pt]
#       line_pts << [proj_end_pt, end_pt]
#       line_pts.each do |line_pt|
#         next if line_pt[0] == line_pt[1] # next if they're the same?
#
#         return false if self.is_line_crossing_gap?(line_pt[0], line_pt[1])
#       end
#       true
#     end
#
#     # Checks if the vector crosses any holes or gaps. If so, then false (not on the face).
#     # @param start_pt [Geom::Point3d]
#     # @param end_pt [Geom::Point3d]
#     # @return [Boolean]
#     def is_line_crossing_gap?(start_pt, end_pt)
#       start_arr = start_pt.to_a
#       end_arr = end_pt.to_a
#       key = [start_arr.map {|f| f.truncate(5)}, end_arr.map {|f| f.truncate(5)}]
#
#       val = @cache_manager.retrieve(key) do
#         self.calculate_if_line_crossing_gap?(start_pt, end_pt)
#       end
#       val
#     end
#
#     # @param start_pt [Geom::Point3d]
#     # @param end_pt [Geom::Point3d]
#     # @return [Boolean]
#     def calculate_if_line_crossing_gap?(start_pt, end_pt)
#       pt_with_dists = self.border_interception_pts_along_line(start_pt, end_pt)
#       return false if pt_with_dists.empty? # This shouldn't be possible
#
#       line_pts = pt_with_dists.map {|pt_with_dist| pt_with_dist[0]}
#
#       # Add the start/end pts if they weren't found
#       unless line_pts.first == start_pt
#         line_pts.insert(0, start_pt)
#       end
#       unless line_pts.last == end_pt
#         line_pts << end_pt
#       end
#
#       (line_pts.length - 1).times do |pt_i|
#         cur_pt = line_pts[pt_i]
#         next_pt = line_pts[pt_i + 1]
#
#         mid_pt = self.linear_combination(cur_pt, next_pt)
#         return true unless self.point_on_face?(self.face, mid_pt)
#       end
#       false
#     end
#
#     # @param start_pt [Geom::Point3d]
#     # @param end_pt [Geom::Point3d]
#     # @return [Array<Array<Geom::Point3d, Float>>]
#     def border_interception_pts_along_line(start_pt, end_pt)
#       raise UnexpectedStateError, "start and end points are the same" if start_pt == end_pt
#
#       line = [start_pt, start_pt.vector_to(end_pt).normalize]
#       pt_with_dists = []
#       int_pts = []
#       self.face_loops.loop_to_loop_vertices.each_pair do |_, other_loop_vertices|
#         other_loop_vertices.each do |other_loop_vertex|
#           int_pt = Geom.intersect_line_line(line, other_loop_vertex.next_line)
#           next if int_pt.nil?
#           next if int_pts.include?(int_pt)
#           next unless self.point_on_face?(self.face, int_pt)
#           next unless self.point_on_line?(start_pt, end_pt, int_pt)
#           next unless self.point_on_line?(other_loop_vertex.position, other_loop_vertex.next_vertex.position, int_pt)
#
#           pt_with_dists << [int_pt, start_pt.distance(int_pt).to_f]
#           int_pts << int_pt
#         end
#       end
#
#       pt_with_dists.sort {|a,b| a[1] <=> b[1]}
#     end
#
#     # @param edge [Sketchup::Edge]
#     # @return [Boolean]
#     def is_edge_part_of_inner_loop?(edge)
#       loops = self.face_loops.loop_to_loop_vertices.keys
#       return false if loops.length == 1
#
#       loops[1..loops.length - 1].each do |loop|
#         return true if loop.edges.include?(edge)
#       end
#       false
#     end
#
#     def inspect
#       self.to_s
#     end
#
#   end
#
# end
