# TODO: May 4, 2023: Commented out as it is not being used.
#
# module DM::Bevel
#
#   class CollisionResult
#     NotInBounds = 0
#     InsideBounds = 1
#     OnStartPlane = 2
#     OnMainPlane = 4
#     OnEndPlane = 8
#
#     # @param result [Integer]
#     # @param compare_value [Integer]
#     # @return [Boolean]
#     def self.contains?(result, compare_value)
#       result & compare_value == compare_value
#     end
#   end
#
#   # Abstract class.
#   class CollisionReport
#
#     # @return [BevelEdgeBounds]
#     attr_reader :edge_bound
#     # @return [Integer]
#     attr_reader :collision_result
#
#     # @param edge_bound [BevelEdgeBounds]
#     # @param collision_result [Integer] A bitflag from CollisionResult
#     def initialize(edge_bound, collision_result)
#       raise UnexpectedTypeError, "edge_bound must be of type BevelEdgeBounds" unless edge_bound.instance_of?(BevelEdgeBounds)
#
#       @edge_bound = edge_bound
#       @collision_result = collision_result
#
#       @cache_manager = CacheManager.new
#     end
#
#     # @param edge_bound [BevelEdgeBounds]
#     # @param result [Integer]
#     # @return [Geom::Point3d]
#     def vert_pt(edge_bound = self.edge_bound, result = self.collision_result)
#       # Get the source vert_pt
#       if CollisionResult.contains?(result, CollisionResult::OnStartPlane)
#         vert_pt = edge_bound.start_loop_vertex.position
#       elsif CollisionResult.contains?(result, CollisionResult::OnEndPlane)
#         vert_pt = edge_bound.end_loop_vertex.position
#       else
#         raise UnexpectedStateError # TODO: LOgic check. DOn't think it's ever possible to land on the Main Plane?
#       end
#       vert_pt
#     end
#
#     # @return [Float]
#     def max_edge_offset
#       val = @cache_manager.retrieve(:max_edge_offset) do
#         self.calculate_edge_offset
#       end
#       val
#     end
#
#     # @param edge_bound [BevelEdgeBounds]
#     # @param result [Integer]
#     # @return [LoopVertex, nil]
#     def get_colliding_loop_vertex(edge_bound, result)
#       on_start = CollisionResult.contains?(result, CollisionResult::OnStartPlane)
#       on_end = CollisionResult.contains?(result, CollisionResult::OnEndPlane)
#       if on_start && on_end
#         # For now, return nil.
#       else
#         if on_start
#           return edge_bound.start_loop_vertex
#         elsif on_end
#           return edge_bound.end_loop_vertex
#         else
#           # Return nil.
#         end
#       end
#       nil
#     end
#
#     private
#
#     # @return [Float]
#     def calculate_edge_offset
#       raise NotImplementedError
#     end
#
#
#   end
#
#
#   class VertexCollisionReport < CollisionReport
#
#     # @return [Sketchup::Vertex]
#     attr_reader :colliding_vertex
#
#     # @param colliding_vertex [Sketchup::Vertex]
#     def initialize(edge_bound, collision_result, colliding_vertex)
#       raise UnexpectedTypeError, "colliding_vertex must be of type Sketchup::Vertex" unless colliding_vertex.instance_of?(Sketchup::Vertex)
#
#       super(edge_bound, collision_result)
#       @colliding_vertex = colliding_vertex
#     end
#
#     private
#
#     def calculate_edge_offset
#       # We just need the perpendicular distance to the edge_bound.
#       vert_pt = self.colliding_vertex.position
#       proj_pt = vert_pt.project_to_line(self.edge_bound.edge_line)
#       vert_pt.distance(proj_pt).to_f
#     end
#
#   end
#
#
#   class EdgeCollisionReport < CollisionReport
#
#     # @return [Sketchup::Edge]
#     attr_reader :colliding_edge
#     # @return [Geom::Point3d]
#     attr_reader :collision_pt
#
#     # @param colliding_edge [Sketchup::Edge]
#     # @param collision_pt [Geom::Point3d]
#     def initialize(edge_bound, collision_result, colliding_edge, collision_pt)
#       raise UnexpectedTypeError, "colliding_edge must be of type Sketchup::Vertex" unless colliding_edge.instance_of?(Sketchup::Edge)
#
#       super(edge_bound, collision_result)
#       @colliding_edge = colliding_edge
#       @collision_pt = collision_pt.clone
#     end
#
#     private
#
#     def calculate_edge_offset
#       proj_pt = self.collision_pt.project_to_line(self.edge_bound.edge_line)
#       self.collision_pt.distance(proj_pt).to_f
#     end
#
#   end
#
#
#   class BoundCollisionReport < CollisionReport
#
#     # @return [BevelEdgeBounds]
#     attr_reader :colliding_edge_bound
#     # @return [Integer]
#     attr_reader :colliding_bound_result
#     # @return [Geom::Point3d]
#     attr_reader :collision_pt
#
#     # @param colliding_edge_bound [BevelEdgeBounds]
#     # @param collision_pt [Geom::Point3d]
#     # @param colliding_bound_result [Integer] A bitflag from CollisionResult
#     def initialize(edge_bound, collision_result, colliding_edge_bound, colliding_bound_result, collision_pt)
#       raise UnexpectedTypeError, "colliding_edge_bound must be of type BevelEdgeBounds" unless colliding_edge_bound.instance_of?(BevelEdgeBounds)
#       raise UnexpectedStateError, "edge_bound and colliding_edge_bound do not share the same FaceLoops" unless edge_bound.face_loops == colliding_edge_bound.face_loops
#
#       super(edge_bound, collision_result)
#       @colliding_edge_bound  = colliding_edge_bound
#       @colliding_bound_result = colliding_bound_result
#       @collision_pt = collision_pt
#     end
#
#     # Returns the pt where the collision occurs after the offset has been calculated.
#     # @return [Geom::Point3d]
#     def calculated_collision_pt
#       perp_vec = self.edge_bound.perpendicular_vector(self.edge_bound.edge, self.edge_bound.face)
#       offset_vec = self.vert_pt.vector_to(self.collision_pt).normalize
#       ang = offset_vec.angle_between(perp_vec)
#       offset_dist = self.max_edge_offset / Math.cos(ang).abs
#       self.vert_pt.offset(offset_vec, offset_dist)
#     end
#
#     private
#
#     def calculate_edge_offset
#       # TODO: possible for int_pt to be on both OnStartPlane & OnEndPlane
#
#       if CollisionResult.contains?(self.colliding_bound_result, CollisionResult::OnMainPlane)
#         edge_offset = self.calculate_main_plane_offset
#       else
#         # We can just get the perpendicular distance to the collision point.
#         pt = self.collision_pt.project_to_line(self.edge_bound.edge_line)
#         edge_offset = pt.distance(self.collision_pt).to_f
#
#         # TODO: Logic check. Should already be handled in bevel_edge_boundary, but leaving hear for my own sanity.
#         other_pt = self.collision_pt.project_to_line(self.colliding_edge_bound.edge_line)
#         raise UnexpectedStateError unless edge_offset == other_pt.distance(self.collision_pt)
#       end
#       edge_offset
#     end
#
#     # @return [Float]
#     def calculate_main_plane_offset
#       face = self.edge_bound.face_loops.face
#
#       # Figure out what edge_offset would be needed for the two colliding offsets to 'just be touching'.
#       # We know the length of the intercepting lines as: h = h0 + he
#       #   h = hypotenuse
#       #   h0 = hypotenuse at the point where they are just touching, wrt to the intecepting edge_line
#       #   he = hypotenuse at the point where they are just touching, wrt to the loop_vertex
#       # We need to find h0 or he to figure out our maximum edge_offset where they are just touching.
#       h_vec = self.vert_pt.vector_to(self.collision_pt)
#       h = h_vec.length.to_f
#       h_vec.normalize!
#
#       colliding_vec = self.colliding_edge_bound.edge_line[1]
#
#       # Since we are offsetting perpendicular to the edges, we can use sin/cos (we always have a right angle triangle)
#       #   edge_angle = angle wrt to the intercepting edge_line and the hypotenuse
#       #   perp_vec = angle wrt to the loop_vertex.
#       edge_angle = h_vec.angle_between(colliding_vec)
#       perp_vec = self.edge_bound.perpendicular_vector(self.edge_bound.edge, face)
#       perp_vec_ang = perp_vec.angle_between(h_vec)
#
#       # figure out what hypotenuse wrt to the loop_vertex (he).
#       #   h = h0 + he
#       #   minimum_edge_offset = h0 * sin(edge_angle)
#       #   minimum_edge_offset = he * cos(edge_vert_angle)
#       # Which then gives us:
#       #   h0 * sin(edge_angle) = he * cos(edge_vert_angle)
#       #   h0 / he = cos(edge_vert_angle) / sin(edge_angle)
#       # Sub in h0 = h - he:
#       #   (h - he) / he = cos(edge_vert_angle) / sin(edge_angle)
#       #   he = h / (cos(edge_vert_angle) / sin(edge_angle) + 1)
#       h_e = h / ((Math.cos(perp_vec_ang) / Math.sin(edge_angle)).abs + 1)
#
#       # With he, we can not find the minimum_edge_offset
#       edge_offset = h_e * Math.cos(perp_vec_ang)
#       edge_offset.abs
#     end
#
#   end
#
#
#   class SharedEdgeCollisionReport < CollisionReport
#     # @return [BevelEdgeBounds]
#     attr_reader :colliding_edge_bound
#     # @return [Integer]
#     attr_reader :colliding_bound_result
#     # @return [Sketchup::Edge]
#     attr_reader :shared_edge
#
#     # @param colliding_edge_bound [BevelEdgeBounds]
#     # @param colliding_bound_result [Integer] A bitflag from CollisionResult
#     # @param shared_edge [Sketchup::Edge]
#     def initialize(edge_bound, collision_result, colliding_edge_bound, colliding_bound_result, shared_edge)
#       raise UnexpectedTypeError, "colliding_edge_bound must be of type BevelEdgeBounds" unless colliding_edge_bound.instance_of?(BevelEdgeBounds)
#       raise UnexpectedStateError, "edge_bound and colliding_edge_bound do not share the same FaceLoops" unless edge_bound.face_loops == colliding_edge_bound.face_loops
#       raise UnexpectedTypeError, "shared_edge must be of type Sketchup::Edge" unless shared_edge.instance_of?(Sketchup::Edge)
#
#       super(edge_bound, collision_result)
#       @colliding_edge_bound  = colliding_edge_bound
#       @colliding_bound_result = colliding_bound_result
#       @shared_edge = shared_edge
#     end
#
#     private
#
#     def calculate_edge_offset
#       # Get the colliding vert pt
#       colliding_vert_pt = self.vert_pt(self.colliding_edge_bound, self.colliding_bound_result)
#
#       face = self.edge_bound.face_loops.face
#       face_corner = self.edge_bound.face_corner(self.get_colliding_loop_vertex(self.edge_bound, self.collision_result))
#       colliding_face_corner = self.colliding_edge_bound.face_corner(self.get_colliding_loop_vertex(self.colliding_edge_bound, self.colliding_bound_result))
#       if face_corner.instance_of?(ParallelFaceCorner) || colliding_face_corner.instance_of?(ParallelFaceCorner)
#         # If there's one ParallelFaceCorner, the that ParallelFaceCorner's bevel offset won't colliding with the normal bevel offset.
#         if face_corner.instance_of?(ParallelFaceCorner)
#           vert_pt = self.vert_pt
#           edge_line = self.colliding_edge_bound.edge_line
#         else
#           vert_pt = colliding_vert_pt
#           edge_line = self.edge_bound.edge_line
#         end
#
#         proj_pt = vert_pt.project_to_line(edge_line)
#         edge_offset = proj_pt.distance(vert_pt).to_f
#       else
#         perp_vec = self.edge_bound.perpendicular_vector(self.edge_bound.edge, face)
#         colliding_perp_vec = self.colliding_edge_bound.perpendicular_vector(self.colliding_edge_bound.edge,face)
#
#         # Using Trig at the colliding vertices, we know:
#         #   h = ho + he
#         #   ho = edge_offset / cos(angle_ho)
#         #   he = edge_offset / cos(angle_he)
#         # Sub into h:
#         #   x = h / (1 / cos(angle_ho) + 1 / cos(angle_he))
#         shared_vec = self.vert_pt.vector_to(colliding_vert_pt).normalize
#         vert_angle = perp_vec.angle_between(shared_vec)
#         colliding_vert_angle = colliding_perp_vec.angle_between(shared_vec.reverse)
#         h = self.vert_pt.distance(colliding_vert_pt).to_f
#
#         edge_offset = h / (1.0 / Math.cos(vert_angle) + 1.0 / Math.cos(colliding_vert_angle))
#       end
#
#       edge_offset.abs
#     end
#
#
#   end
#
#
#
# end
