
module DM::Bevel

  class FakeFaceCorner < FaceCorner

    # @param edge_vert1 [EdgeVertex]
    # @param edge_vert2 [EdgeVertex]
    # @param fake_face [FakeFace]
    def initialize(edge_vert1, edge_vert2, fake_face)
      raise UnexpectedStateError, "Cannot have Primary edge_verts in a FakeFaceCorner" if edge_vert1.primary? || edge_vert2.primary?
      raise UnexpectedTypeError, "fake_face must be of type FakeFace" unless fake_face.instance_of?(FakeFace)
      raise UnexpectedStateError, "edge_verts do not contain the fake_face" unless edge_vert1.faces.include?(fake_face) && edge_vert2.faces.include?(fake_face)

      super(edge_vert1, edge_vert2)
      @fake_face = fake_face
    end

    # @return [FakeFace]
    def face
      @fake_face
    end

    # @return [Array<FakeFace>]
    def faces
      [self.face]
    end

    def face_between?
      true # TODO: For now, let's say it's always between...
    end

    # The vector in the direction of the Face.
    # def mid_vector
    #   face_vec =  self.edge_vert2.edge_vector * self.face.normal
    #   # Make sure the vector is in the shared face direction.
    #   pt = self.vertex.position.offset(face_vec, 0.01)
    #   face_vec.reverse! unless self.point_on_face?(self.face, pt)
    #   face_vec
    # end

    # @param other_face_corner [FaceCorner]
    # @return [Boolean]
    def ==(other_face_corner)
      return false unless super
      self.face == other_face_corner.face
    end

    alias eql? :==

    def hash
      @edge_vert1.hash + @edge_vert2.hash + @face.hash
    end

    def inspect
      self.to_s
    end

  end

end