#
# module DM::Bevel
#
#   class DebugBevelTool < BaseTool
#
#     def initialize
#       # DB.clear
#       super
#     end
#
#     def disable_draw?
#       Sketchup.read_default(MAIN_DICTIONARY, 'disable_draw', false)
#     end
#
#     def disable_draw=(val)
#       Sketchup.write_default(MAIN_DICTIONARY, 'disable_draw', val == true)
#     end
#
#     def enable_speedup?
#       Sketchup.read_default(MAIN_DICTIONARY, 'enable_speedup', false)
#     end
#
#     def enable_speedup=(val)
#       Sketchup.write_default(MAIN_DICTIONARY, 'enable_speedup', val == true)
#     end
#
#     # @return [BevelParams]
#     def load_params
#       params = BevelParams.new
#       params.instance_variables.each do |sym|
#         key = sym.to_s.gsub('@', '')
#         default_value = params.instance_variable_get(sym)
#
#         val = Sketchup.read_default(MAIN_DICTIONARY, key, default_value)
#         params.instance_variable_set(sym, val)
#       end
#       params
#     end
#
#     def save_params
#       @bevel_params.instance_variables.each do |sym|
#         key = sym.to_s.gsub('@', '')
#         value = @bevel_params.instance_variable_get(sym)
#         Sketchup.write_default(MAIN_DICTIONARY, key, value)
#       end
#     end
#
#     def on_preselection
#       # Preselection logic
#       model = Sketchup.active_model
#       edges = collect_valid_edges(model.selection)
#       model.selection.clear
#       add_edges_to_selected(edges) unless edges.empty?
#     rescue InvalidEdgeError => err
#       puts '======= on_preselection '
#       get_invalid_edge_tooltips(err).each do |msg|
#         puts msg
#       end
#     ensure
#       model.selection.clear
#     end
#
#     def deactivate(view)
#       super
#     end
#
#     def set_status_text
#       cur_state = Sketchup.active_model.rendering_options["DrawHidden"]
#       Sketchup::set_status_text("(TAB) Show Hidden Geometry = #{cur_state.to_s} | (ALT) Smooth Perimeter? = #{@bevel_params.smooth_perimeter?.to_s} | (`) Disable Draw = #{self.disable_draw?.to_s} | (.) Enable SpeedUp = #{self.enable_speedup?.to_s} ")
#     end
#
#     def set_vcb
#       Sketchup.set_status_text("Segments, Edge offset", SB_VCB_LABEL)
#       Sketchup.set_status_text("#{@bevel_params.segments}, #{@bevel_params.edge_offset.to_l}", SB_VCB_VALUE)
#     end
#
#     # @param view [Sketchup::View]
#     def onCancel(reason, view)
#       super
#     end
#
#     def onUserText(text, view)
#       if text[-1] == 's'
#         segs = text[0..-2].to_i
#         @bevel_params.segments = segs
#       else
#         offset = text.to_l
#         @bevel_params.edge_offset = offset
#       end
#       save_params
#       recalculate_bevels(true)
#       set_vcb
#       set_status_text
#       Sketchup.active_model.active_view.invalidate
#     end
#
#     def onKeyDown(key, repeat, flags, view)
#       suppress = false
#       if key == 107 # +
#         if @bevel_params.single_segment?
#           @bevel_params.segments = 2
#         else
#           @bevel_params.segments += 2
#         end
#         recalculate_bevels(true)
#         save_params
#         suppress = true
#       elsif key == 109 # -
#         if @bevel_params.segments == 2
#           @bevel_params.segments = 1
#         else
#           @bevel_params.segments -= 2
#         end
#         recalculate_bevels(true)
#         save_params
#         suppress = true
#       elsif key == ALT_MODIFIER_KEY
#         @bevel_params.smooth_perimeter = !@bevel_params.smooth_perimeter?
#         save_params
#         suppress = true
#       elsif key == 9 # tab
#         Sketchup.active_model.rendering_options["DrawHidden"] = !Sketchup.active_model.rendering_options["DrawHidden"]
#         suppress = true
#       elsif key == 111 # /
#         @bevel_params.edge_offset -= "0.01m".to_l.to_f
#         recalculate_bevels(true)
#         save_params
#         suppress = true
#       elsif key == 106 # *
#         @bevel_params.edge_offset += "0.01m".to_l.to_f
#         recalculate_bevels(true)
#         save_params
#         suppress = true
#       elsif key == 192 # `
#         self.disable_draw = !self.disable_draw?
#         suppress = true
#       elsif key == 220 # \
#         self.enable_speedup = !self.enable_speedup?
#         suppress = true
#       end
#
#       set_vcb if suppress
#       set_status_text
#       view.invalidate
#       suppress
#     end
#
#     # @param view [Sketchup::View]
#     def onMouseMove(flags, x, y, view)
#       @hovered_edges.clear
#       @hovered_edges.concat(get_edges_below_cursor(view, x, y))
#     rescue InvalidEdgeError => err
#       msgs = get_invalid_edge_tooltips(err)
#       view.tooltip = msgs.first unless msgs.empty?
#     end
#
#     # @param view [Sketchup::View]
#     def onLButtonDown(flags, x, y, view)
#       return if @hovered_edges.empty?
#
#       add_edges_to_selected(@hovered_edges.uniq)
#       view.invalidate
#     end
#
#     def onLButtonDoubleClick(flags, x, y, view)
#       return if @hovered_edges.empty?
#
#       all_edges = []
#       @hovered_edges.each do |edge|
#         all_edges.concat(collect_valid_edges(edge.all_connected))
#       end
#       add_edges_to_selected(all_edges)
#     rescue InvalidEdgeError => err
#       msgs = get_invalid_edge_tooltips(err)
#       view.tooltip = msgs.first unless msgs.empty?
#     ensure
#       view.invalidate
#     end
#
#     # @param picked_edges [Array<Sketchup::Edge>]
#     def add_edges_to_selected(picked_edges)
#       # Group the edges together based on if they are connected.
#       grouped_edges = []
#       matched_edges = []
#       picked_edges.each do |edge|
#         next if matched_edges.include?(edge)
#
#         related_edges = picked_edges & edge.all_connected
#         matched_edges.concat(related_edges)
#         grouped_edges << related_edges
#       end
#
#       grouped_edges.each do |edge_group|
#         did_add = false
#         @bevel_datas.each do |b_data|
#           next if (b_data.all_connected_edges & edge_group).empty? # There is no related edges.
#
#           b_data.add_edges(edge_group)
#           did_add = true
#           break
#         end
#
#         next if did_add
#
#         bevel_data = BevelData.new
#         bevel_data.add_edges(edge_group)
#         bevel_data.params = @bevel_params
#         @bevel_datas << bevel_data
#       end
#       recalculate_bevels(false) unless self.disable_draw?
#     end
#
#     # @param force_recalculation [Boolean]
#     def recalculate_bevels(force_recalculation = false)
#       @bevel_datas.each do |b_data|
#         b_data.calculate if force_recalculation || !b_data.full_calculation?
#       end
#     end
#
#     def onReturn(view)
#       model = Sketchup.active_model
#       model.start_operation("Debug Create Bevel", true)
#       if enable_speedup?
#         SpeedUp.profile { self.create_bevel(@bevel_datas, true) }
#       else
#         self.create_bevel(@bevel_datas)
#       end
#       model.commit_operation
#
#       self.reset
#       view.invalidate
#     end
#
#     # @param bevel_datas [Array<BevelData>]
#     def create_bevel(bevel_datas, force_recalc = false)
#       model = Sketchup.active_model
#       beveler = Beveler.new
#       bevel_datas.each do |b_data|
#         b_data.calculate if force_recalc || !b_data.full_calculation?
#         beveler.data = b_data
#         beveler.generate_geometry(model.active_entities)
#       end
#     end
#
#     # @param view [Sketchup::View]
#     def draw(view)
#       # view.dynamic = true
#       view.line_width = 3
#       # SpeedUp.profile {
#       view.drawing_color = 'blue'
#       @bevel_datas.each do |b_data|
#         b_data.primary_edges.each do |edge|
#           view.draw_line(edge.start.position, edge.end.position)
#         end
#       end
#
#       if self.disable_draw?
#         DB.clear
#         return
#       end
#
#       @bevel_datas.each do |b_data|
#         b_data.calculate(false)
#         draw_bevel_data(b_data)
#         beveler = Beveler.new
#         beveler.data = b_data
#         beveler.generate_geometry(Sketchup.active_model.active_entities, false, true)
#       end
#       # }
#     rescue BevelDebugError => error
#       [error.source, error.cause].each_with_index do |error_obj, i|
#         next if error_obj.nil?
#
#         data = error_obj.instance_of?(Array) ? error_obj : [error_obj]
#         data.each do |obj|
#           next if obj.nil?
#
#           pt = nil
#           if obj.respond_to?(:position)
#             pt = obj.position
#           elsif obj.respond_to?(:vertex)
#             pt = obj.vertex.position
#           end
#           next if pt.nil?
#
#           reason = i == 0 ? 'Source' : 'Cause'
#           DB.draw_pt_text(pt, "#{reason}: #{obj.class}")
#         end
#       end
#
#       raise
#     end
#
#     # @param bevel_data [BevelData]
#     def draw_bevel_data(bevel_data)
#       return if bevel_data.none_calculated?
#
#       bevel_data.each_transition.each do |transition_segment|
#         transition_segment.loop_with_opposite do |pt, opposite_pt|
#           DB.draw_line2d([pt, opposite_pt], 1, 'orange', '-')
#         end
#         t_s_color = transition_segment.curve.instance_of?(PointCurve) ? 'green' : 'orange'
#         DB.draw_line2d(transition_segment.curve.points, 3, t_s_color, '-')
#       end
#
#       return if bevel_data.partial_calculation?
#
#       bevel_data.corner_to_patch.each_pair do |corner, corner_patch|
#         center_patch = corner_patch.center_patch
#         if bevel_data.params.single_segment?
#           # pts = center_patch.surrounding_pts.clone
#           # pts << pts.first
#           # DB.draw_line2d(pts, 2, 'purple', '-')
#         else
#           DB.draw_pts(center_patch.center_pt, 7, 2, 'purple')
#           corner_patch.transition_segment_to_point_curves.each_value do |all_curve_pts|
#             all_curve_pts.each do |curve_pts|
#               pts = curve_pts.points
#               # DB.draw_pts(pts, 7, 2, 'purple') unless @bevel_data.params.segments > 30 # TODO: Temp for perfomance
#               DB.draw_line2d(pts, 2, 'purple', '-')
#             end
#             DB.draw_line2d([center_patch.center_pt, all_curve_pts.last[all_curve_pts.last.length / 2]], 2, 'purple', '-')
#           end
#         end
#       end
#     end
#
#   end
#
#
# end