#
# module DM::Bevel
#
#   class DB
#     @@draw_objects = []
#     @@hash_objects = {}
#     @@temp_properties = { }
#
#     @@color_hash = {}
#
#     def self.clear
#       @@draw_objects.clear
#       @@hash_objects.clear
#       @@temp_properties.clear
#     end
#
#     # @return [Hash]
#     def self.temp
#       @@temp_properties
#     end
#
#     def self.puts_backtrace
#       backtrace = "\n" + caller.join("\r\n")
#       puts backtrace
#     end
#
#     # @param view [Sketchup::View]
#     def self.draw(view)
#       # @type [Hash{Geom::Point3d => Integer}]
#       text_pt_array_hash = Hash.new {|h,k| h[k] = 0 }
#       @@draw_objects.each do |data|
#         case data[:type]
#         when POINTS_TYPE
#           view.draw_points(data[:points], data[:size], data[:style], get_color(data[:color]))
#         when TEXT_TYPE
#           pt_key = data[:point].to_a.map {|f| f.round(5) }
#           pos_i = text_pt_array_hash[pt_key]
#           text = data[:text]
#           pos_i.times { |_| text = " \n#{text}"}
#           text_pt_array_hash[pt_key] += 1
#
#           view = Sketchup.active_model.active_view
#           screen_pt = view.screen_coords(data[:point])
#           view.draw_text(screen_pt, text, size: data[:size], color: get_color(data[:color]))
#         when LINE_TYPE
#           view.drawing_color = get_color(data[:color])
#           view.line_stipple = data[:stipple]
#           view.line_width = data[:size]
#           view.draw(GL_LINE_STRIP, data[:line])
#           view.line_stipple = '' # reset it
#         when LINE2D_TYPE
#           line = []
#           lines = []
#           data[:line].each do |pt|
#             s_pt = view.screen_coords(pt)
#             # if s_pt.x.abs > view.vpwidth * 2 || s_pt.y.abs > view.vpheight * 2 # weird bug when you zoom in too much.
#             #   lines << line
#             #   line = []
#             # else
#               line << s_pt
#             # end
#           end
#           lines << line
#           view.drawing_color = get_color(data[:color])
#           view.line_stipple = data[:stipple]
#           view.line_width = data[:size]
#           lines.each do |line|
#             next if line.length < 2
#             view.draw2d(GL_LINE_STRIP, line)
#           end
#           view.line_stipple = '' # reset it
#         when POLYGON_TYPE
#           color = get_color(data[:color])
#           color.alpha = 0.2
#           view.drawing_color = color
#           view.line_stipple = data[:stipple]
#           view.line_width = data[:size]
#           line = data[:points].map {|pt| view.screen_coords(pt)}
#           view.draw2d(GL_POLYGON, line)
#           view.line_stipple = '' # reset it
#         end
#       end
#
#       @@hash_objects.each_value do |data|
#         view.draw_points(data[:points], data[:size], data[:style], get_color(data[:color]))
#         view.drawing_color = get_color(data[:color])
#         view.line_stipple = '-'
#         view.line_width = 2
#
#         points_2d = data[:points].map {|pt| view.screen_coords(pt)}
#         view.draw2d(GL_LINE_STRIP, points_2d) unless points_2d.length < 2
#         view.line_stipple = '' # reset it
#         points_2d.each_with_index do |screen_pt, i|
#           pt_key = screen_pt.to_a.map {|f| f.round(5)}
#           pos_i = text_pt_array_hash[pt_key]
#           text = i.to_s
#           pos_i.times { |_| text = " \n#{text}"}
#           text_pt_array_hash[pt_key] += 1
#           view.draw_text(screen_pt, text, size: 12, bold: true)
#         end
#       end
#     end
#
#
#     # @param key [String]
#     # @param pts [Array<Geom::Point3d>]
#     # @param size [Integer]
#     # @param color [String]
#     def self.trace_points(key, pts, size, color)
#       collection = @@hash_objects[key]
#       collection = { points: [] } if collection.nil?
#
#       pts = [pts] unless pts.is_a?(Enumerable)
#       pts.each do |pt|
#         raise ArgumentError, "Invalid point provided" unless pt.instance_of?(Geom::Point3d)
#       end
#       get_color(color) # Will throw an exception if the color is invalid
#
#       collection[:points].concat(pts.map{|pt| pt.clone })
#       collection[:size] = size.to_i
#       collection[:style] = 2
#       collection[:color] = color
#
#       @@hash_objects[key] = collection
#     end
#
#     # @param pts [Array<Geom::Point3d>]
#     # @param size [Integer]
#     # @param style [Integer] A value between 1 to 7
#     # @param color [String]
#     def self.draw_pts(pts, size = 12, style = 2, color = 'red')
#       pts = [pts] unless pts.is_a?(Enumerable)
#       pts.each do |pt|
#         raise ArgumentError, "Invalid point provided" unless pt.instance_of?(Geom::Point3d)
#       end
#       get_color(color) # Will throw an exception if the color is invalid
#
#       add_data(POINTS_TYPE, points: pts.map {|pt| pt.clone}, size: size.to_i, style: style.to_i, color: color)
#     end
#
#     # Alias of draw_pts
#     # @param pts [Array<Geom::Point3d>]
#     # @param size [Integer]
#     # @param style [Integer] A value between 1 to 7
#     # @param color [String]
#     def self.draw_pt(pts, size = 12, style = 2, color = 'red')
#       self.draw_pts(pts, size, style, color)
#     end
#
#     # @param pts [Array<Geom::Point3d>]
#     # @param size [Integer]
#     # @param color [String]
#     def self.draw_pts_with_index(pts, size = 12, color = 'red')
#       pts = [pts] unless pts.is_a?(Enumerable)
#       pts.each do |pt|
#         raise ArgumentError, "Invalid point provided" unless pt.instance_of?(Geom::Point3d)
#       end
#
#       pts.each_with_index do |pt, i|
#         self.draw_pt_text(pt, i, size, color)
#       end
#     end
#
#     # @param pt [Array<Geom::Point3d>]
#     # @param text [String]
#     # @param size [Integer]
#     # @param color [String]
#     def self.draw_text(pt, text, size = 13, color = 'black')
#       raise ArgumentError, "Invalid point provided" unless pt.instance_of?(Geom::Point3d)
#       get_color(color) # Will throw an exception if the color is invalid
#
#       # view = Sketchup.active_model.active_view
#       # screen_pt = view.screen_coords(pt)
#       add_data(TEXT_TYPE, point: pt.clone, text: text.to_s, size: size.to_i, color: color)
#     end
#
#     # @param pt [Array<Geom::Point3d>]
#     # @param text [String]
#     # @param size [Integer]
#     # @param color [String]
#     def self.draw_pt_text(pt, text, size = 12, color = 'red')
#       self.draw_pts(pt, size, 2, color)
#       self.draw_text(pt, text)
#     end
#
#     # @param pts [Array<Geom::Point3d>]
#     # @param size [Integer]
#     # @param color [String]
#     # @param stipple [String]
#     def self.draw_line(pts, size = 2, color = 'black', stipple = '')
#       raise ArgumentError, "Must be an array of points." unless pts.is_a?(Enumerable)
#       pts.each do |pt|
#         raise ArgumentError, "Invalid point provided" unless pt.instance_of?(Geom::Point3d)
#       end
#       get_color(color) # Will throw an exception if the color is invalid
#
#       add_data(LINE_TYPE, line: pts.map {|pt| pt.clone}, size: size.to_i, color: color, stipple: stipple.to_s)
#     end
#
#     # @param pts [Array<Geom::Point3d>]
#     # @param size [Integer]
#     # @param color [String]
#     # @param stipple [String]
#     def self.draw_line2d(pts, size = 2, color = 'black', stipple = '')
#       raise ArgumentError, "Must be an array of points." unless pts.is_a?(Enumerable)
#       pts.each do |pt|
#         raise ArgumentError, "Invalid point provided" unless pt.instance_of?(Geom::Point3d)
#       end
#       get_color(color) # Will throw an exception if the color is invalid
#
#       add_data(LINE2D_TYPE, line: pts.map {|pt| pt.clone}, size: size.to_i, color: color, stipple: stipple.to_s)
#     end
#
#
#     # @param pts [Array<Geom::Point3d>]
#     # @param size [Integer]
#     # @param color [String]
#     # @param stipple [String]
#     def self.draw_polygon(pts, size = 2, color ='darkblue', stipple = '')
#       raise ArgumentError, "Must be an array with at least 3 points" unless pts.length >= 3
#       pts.each do |pt|
#         raise ArgumentError, "Invalid point provided" unless pt.instance_of?(Geom::Point3d)
#       end
#       get_color(color) # Will throw an exception if the color is invalid
#
#       add_data(POLYGON_TYPE, points: pts.map {|pt| pt.clone}, size: size.to_i, color: color, stipple: stipple.to_s)
#     end
#
#     # @param faces [Array<Sketchup::Face>]
#     # @param transform [Geom::Transformation] Nil, if at parent coords
#     # @param size [Integer]
#     # @param color [String]
#     # @param stipple [String]
#     def self.draw_faces(faces, transform = nil, size = 2, color = 'darkblue', stipple = '')
#       faces = [faces] unless faces.is_a?(Enumerable)
#       faces.each do |face|
#         raise ArgumentError, "Not a valid Face" unless face.valid?
#       end
#
#       faces.each do |face|
#         pts = []
#         face.outer_loop.vertices.each do |vert|
#           pt = vert.position
#           pt.transform!(transform) unless transform.nil?
#           pts << pt
#         end
#         pts << pts.first
#         self.draw_line2d(pts, size, color, stipple)
#
#         center_pt = centroid(pts)
#         vec = face.normal
#         vec.transform!(transform) unless transform.nil?
#         offset_pt = center_pt.offset(vec, 8.0)
#         self.draw_line2d([center_pt, offset_pt], size, color, stipple)
#         self.draw_pts(center_pt, 8, 2, color)
#         self.draw_pts(offset_pt, 8, 2, color)
#         yield(center_pt) if block_given?
#       end
#     end
#
#     # @param pts [Array<Geom::Point3d>]
#     # @param size [Integer]
#     # @param style [Integer] A value between 1 to 7
#     # @param color [String]
#     def self.draw_length(pts, size = 12, style = 2, color = 'purple')
#       raise ArgumentError, "Must have exactly two points" unless pts.length == 2
#
#       self.draw_pts(pts, size,style,color)
#       self.draw_line2d(pts, 2, color, '-')
#       mid_pt = Geom::linear_combination(0.5, pts[0], 0.5, pts[1])
#       self.draw_text(mid_pt, pts[0].distance(pts[1]).to_f.round(4))
#     end
#
#     # @param vectors [Array<Geom::Vector3d>]
#     # @param origin [Geom::Point3d]
#     # @oaram opts [Hash]
#     # @option opts [Geom::Transformation] :coordinate_trans The coordinate system the vectors sits in.
#     # @option opts [String] :color
#     def self.draw_vector(vectors, origin, **opts)
#       coordinate_trans = opts[:coordinate_trans]
#       coordinate_trans = Geom::Transformation.new if coordinate_trans.nil?
#       color = opts[:color]
#       color = 'black' if color.nil?
#
#       # coordinate_trans = Sketchup.active_model.edit_transform, origin = nil, color = 'black'
#       vectors = [vectors] unless vectors.is_a?(Enumerable)
#       vectors.each do |vec|
#         raise ArgumentError, "Not a valid vector" unless vec.valid?
#       end
#       raise ArgumentError, "Not a point" unless origin.instance_of?(Geom::Point3d)
#
#       origin = coordinate_trans.origin if origin.nil?
#       # self.draw_transform(coordinate_trans, 2, 20, origin)
#       vectors.each do |vec|
#         pts = [origin, origin.offset(vec, 30)]
#         self.draw_line2d(pts, 3, color)
#       end
#     end
#
#     # @param line [Array<Geom::Point3d, Geom::Vector3d>]
#     # @param origin [Geom::Point3d]
#     # @oaram opts [Hash]
#     # @option opts [Geom::Transformation] :coordinate_trans The coordinate system the vectors sits in.
#     # @option opts [String] :color
#     def self.draw_geom_line(line, **opts)
#       raise ArgumentError, "First value of line must be a Geom::Point3d" unless line[0].instance_of?(Geom::Point3d)
#       raise ArgumentError, "Second value of line must be a Geom::Vector3d" unless line[1].instance_of?(Geom::Vector3d)
#       raise ArgumentError, "Vector3d is not valid" unless line[1].valid?
#
#       color = opts[:color]
#       color = 'red' if color.nil?
#
#       pt = line[0].offset(line[1], 30)
#       self.draw_pt(line[0], 20, 2, color)
#       self.draw_line2d([line[0], pt], 3, color)
#     end
#
#     # @param trans [Geom::Transformation]
#     # @param size [Integer]
#     # @param length [Integer]
#     # @param origin [Geom::Point3d] Allows offsetting the point
#     def self.draw_transform(trans, size, length, origin = nil)
#       raise ArgumentError, "Not a point" if !origin.nil? && !origin.instance_of?(Geom::Point3d)
#
#       origin = trans.origin if origin.nil?
#       self.draw_pts(origin, 12, 2, 'black')
#       self.draw_line2d([origin, origin.offset(trans.xaxis, length)], size, 'red', '-')
#       self.draw_line2d([origin, origin.offset(trans.yaxis, length)], size, 'green', '-')
#       self.draw_line2d([origin, origin.offset(trans.zaxis, length)], size, 'blue', '-')
#     end
#
#     # @param edges [Array<Sketchup::Edge>]
#     # @param transform [Geom::Transformation] Nil, if at parent coords
#     # @param size [Integer]
#     # @param color [String]
#     # @param stipple [String]
#     def self.draw_edges(edges, size = 2, color = 'red', stipple = '', transform = nil)
#       edges = [edges] unless edges.is_a?(Enumerable)
#       edges.each do |edge|
#         raise ArgumentError, "Not a valid Edge" unless edge.valid?
#       end
#
#       edges.each do |edge|
#         pts = [edge.start.position, edge.end.position]
#         pts.map! {|pt| pt.transform(transform) } unless transform.nil?
#         self.draw_line2d(pts, size, color, stipple)
#         self.draw_pts(pts, 8, 2, color)
#       end
#     end
#
#     # @param bb [Geom::BoundingBox]
#     def self.draw_bounds(bb)
#       bottom = [bb.corner(0), bb.corner(1), bb.corner(3), bb.corner(2)]
#       top = [bb.corner(4), bb.corner(5), bb.corner(7), bb.corner(6)]
#       DB.draw_polygon(bottom)
#       DB.draw_polygon(top)
#
#       bottom.length.times do |i|
#         pt1 = bottom[i]
#         pt2 = bottom[i + 1]
#         pt2 = bottom[0] if pt2.nil?
#
#         pt3 = top[i]
#         pt4 = top[i + 1]
#         pt4 = top[0] if pt4.nil?
#
#         box = [
#           pt1, pt2, pt4, pt3
#         ]
#         DB.draw_polygon(box)
#       end
#       # DB.draw_pts(bottom)
#       # DB.draw_pts(top)
#     end
#
#     private
#
#     POINTS_TYPE = 1
#     LINE2D_TYPE = 2
#     LINE_TYPE = 3
#     TEXT_TYPE = 4
#     POLYGON_TYPE = 5
#
#     def initialize
#     end
#
#     def self.add_data(type, **data)
#       data[:type] = type
#       @@draw_objects << data
#     end
#
#     # @param color [String]
#     # @return [Sketchup::Color]
#     def self.get_color(color)
#       col = @@color_hash[color]
#       return col unless col.nil?
#
#       col = Sketchup::Color.new(color)
#       @@color_hash[color] = col
#       col
#     end
#
#     # pts is an array of point3d objects
#     # @param pts_or_verts [Array<Geom::Point3d, Sketchup::Vertex>]
#     # @return [Geom::Point3d]
#     def self.centroid(pts_or_verts)
#       num = 0.0
#       sumx = 0.0
#       sumy = 0.0
#       sumz = 0.0
#       pts_or_verts.each { |p|
#         p = p.position if p.instance_of?(Sketchup::Vertex)
#         sumx += p.x
#         sumy += p.y
#         sumz += p.z
#         num += 1.0
#       }
#       Geom::Point3d.new((sumx / num), (sumy / num), (sumz / num))
#     end
#
#     # https://forums.sketchup.com/t/ruby-angle-between-issue/104322
#     # Counter-clockwise angle from vector2 to vector1, as seen from normal.
#     # @param vector1 [Geom::Vector3d]
#     # @param vector2 [Geom::Vector3d]
#     # @param normal [Geom::Vector3d]
#     # @return [Float]
#     def self.angle_in_plane(vector1, vector2, normal = Z_AXIS)
#       Math.atan2((vector2 * vector1) % normal, vector1 % vector2)
#     end
#
#   end
#
#   class DebugWrapperTool
#
#     def initialize(tool)
#       @tool = tool
#       @keys_down = []
#     end
#
#     # @param bool_val [Boolean]
#     def should_persist=(bool_val)
#       Sketchup.write_default('debugger', 'should_persist', bool_val == true)
#     end
#
#     # @return [Boolean]
#     def should_persist?
#       Sketchup.read_default('debugger', 'should_persist', false) == true
#     end
#
#     def call_tool_method(method, *args)
#       @tool.send(method, *args) if @tool.respond_to?(method)
#     end
#
#     def activate
#       self.call_tool_method(__method__)
#     end
#
#     def deactivate(view)
#       self.call_tool_method(__method__, view)
#     end
#
#     def enableVCB?
#       true
#     end
#
#     def getExtents
#       self.call_tool_method(__method__)
#     end
#
#     def getMenu(menu, flags, x, y, view)
#       self.call_tool_method(__method__, menu, flags, x, y, view)
#     end
#
#     def onCancel(reason, view)
#       self.call_tool_method(__method__, reason, view)
#     end
#
#     def suspend(view)
#       self.call_tool_method(__method__, view)
#     end
#
#     def resume(view)
#       self.call_tool_method(__method__, view)
#     end
#
#     def onReturn(view)
#       self.call_tool_method(__method__, view)
#     end
#
#     def onSetCursor
#       self.call_tool_method(__method__)
#     end
#
#     def onUserText(text, view)
#       self.call_tool_method(__method__, text, view)
#     end
#
#     def onKeyDown(key, repeat, flags, view)
#       @keys_down << key
#       self.call_tool_method(__method__, key, repeat, flags, view)
#     end
#
#     def onKeyUp(key, repeat, flags, view)
#       if @keys_down.include?(192) && @keys_down.include?(16) #  shift + `
#         self.should_persist = !self.should_persist?
#         puts "Debugger, Should Persist: #{self.should_persist?}"
#       elsif @keys_down.include?(9) && @keys_down.include?(16)  # shift + tab
#         DB.clear
#         view.invalidate
#         puts "Debugger, Clear"
#       end
#       @keys_down.delete(key)
#       self.call_tool_method(__method__, key, repeat, flags, view)
#     end
#
#     def onMouseEnter(view)
#       self.call_tool_method(__method__, view)
#     end
#
#     def onMouseLeave(view)
#       self.call_tool_method(__method__, view)
#     end
#
#     def onMouseWheel(flags, delta, x, y, view)
#       self.call_tool_method(__method__, flags, delta, x, y, view)
#     end
#
#     def onMouseMove(flags, x, y, view)
#       self.call_tool_method(__method__, flags, x, y, view)
#     end
#
#     def onLButtonDown(flags, x, y, view)
#       self.call_tool_method(__method__, flags, x, y, view)
#     end
#
#     def onLButtonUp(flags, x, y, view)
#       self.call_tool_method(__method__, flags, x, y, view)
#     end
#
#     def onLButtonDoubleClick(flags, x, y, view)
#       self.call_tool_method(__method__, flags, x, y, view)
#     end
#
#     #def onMButtonDown(flags, x, y, view)
#     #  self.call_tool_method(__method__, flags, x, y, view)
#     #end
#     #
#     #def onMButtonUp(flags, x, y, view)
#     #  self.call_tool_method(__method__, flags, x, y, view)
#     #end
#     #
#     #def onMButtonDoubleClick(flags, x, y, view)
#     #  self.call_tool_method(__method__, flags, x, y, view)
#     #end
#
#     def onRButtonDoubleClick(flags, x, y, view)
#       self.call_tool_method(__method__, flags, x, y, view)
#     end
#
#     def onRButtonDown(flags, x, y, view)
#       self.call_tool_method(__method__, flags, x, y, view)
#     end
#
#     def onRButtonUp(flags, x, y, view)
#       self.call_tool_method(__method__, flags, x, y, view)
#     end
#
#     def draw(view)
#       self.call_tool_method(__method__, view)
#     ensure
#       DB.draw(view)
#       DB.clear unless self.should_persist?
#     end
#
#   end
#
# end
