module DM
module Bevel
# THIS FILE IS CREATED WHEN BUILD LICENSE RUN!!
class DMLanguageHandler < LanguageHandler
PATH = File.dirname(__FILE__)
MAIN_DICTIONARY = 'Bevel'
# Over-ride this method from parent class to load language file from user preferences
# @param [String] strings_file_name
# @param [String] extension_file_path
# @return [String, Nil]
# @since SketchUp 2014
def find_strings_file(strings_file_name, extension_file_path = nil)
get_strings_file
end
def language_file
Sketchup.read_default(MAIN_DICTIONARY, 'language', 'English')
end
def language_file=(value)
Sketchup.write_default(MAIN_DICTIONARY, 'language', value)
end
def available_languages
resource_folder_path = File.join(PATH, 'Resources')
files = Dir.entries(resource_folder_path)
#files = files.collect { |f| f.force_encoding('UTF-8') if f.respond_to?(:force_encoding)}
language_files = files.find_all { |f| f[-8..-1] == '.strings' }
language_files = language_files.collect { |f| File.basename(f, '.strings') }
if language_files.empty?
language_files = ['English'] # Even if there are no .strings files, we know that English is always an option
end
language_files
end
def get_strings_file
string_file = File.join(PATH, 'Resources', self.language_file + '.strings')
if File.exist?(string_file)
string_file
else
nil
end
end
end
end
end
